=== debian/changelog ===
cmake-format (0.6.13-7) unstable; urgency=medium

  * Backport upstream PR #353 which drops the requirement for python3-six.
    Thanks to Alexandre Detiste (Closes: #1110560)
  * Update to debhelper 13. No changes required.
  * Update to standards-version 4.7.2. No changes required.

 -- Ian Campbell <ijc@debian.org>  Mon, 11 Aug 2025 14:09:23 +0100

cmake-format (0.6.13-6) unstable; urgency=medium

  * Drop unnecessary/unused dependency on python3-pkg-resources
    (Closes: #1083340).

 -- Ian Campbell <ijc@debian.org>  Sun, 06 Oct 2024 13:54:37 +0100

cmake-format (0.6.13-5) unstable; urgency=medium

  * Add DEP-3 Forwarded tags to all patches.

 -- Ian Campbell <ijc@debian.org>  Sun, 27 Aug 2023 10:00:53 +0100

cmake-format (0.6.13-4) unstable; urgency=medium

  * Depend on newer dh-python in order to remove *.egg-info in clean
    (Closes: #1043743).

 -- Ian Campbell <ijc@debian.org>  Sat, 26 Aug 2023 11:58:53 +0100

cmake-format (0.6.13-3) unstable; urgency=medium

  * Update to support Python 3.11 (Closes: #1028176)
  * Update Standards Version (no changes required)

 -- Ian Campbell <ijc@debian.org>  Sun, 08 Jan 2023 09:17:35 +0000

cmake-format (0.6.13-2) unstable; urgency=medium

  * Correct typos in manpage/command line options and whatis entry of manpages.
  * Add a debian/watch file.

 -- Ian Campbell <ijc@debian.org>  Sun, 04 Oct 2020 15:56:05 +0100

cmake-format (0.6.13-1) unstable; urgency=medium

  * New upstream release.
  * Disable TestCommandDatabase test (Closes: #971117).

 -- Ian Campbell <ijc@debian.org>  Fri, 02 Oct 2020 20:18:14 +0100
