=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/cmakeformat-$1\.tar\.gz/ \
  https://github.com/cheshirekow/cmake_format/tags .*/v?(\d\S+)\.tar\.gz
